local text_width = 80
local valuebox_width = 100

create_gui = vb:column{
    style="panel",
    spacing=4,
    margin=4,
    vb:horizontal_aligner{
        mode = "distribute",
        vb:row{
            vb:text{text="Nr. samples:", width=text_width},
            vb:valuebox{
                id="nr_samples",
                width=valuebox_width,
                height=20,
                min=3,
                max=512,
                value=3,
                steps={1, 5},
                notifier = function(value)
                    --
                end
            },
        },
    },
    vb:horizontal_aligner{
        mode = "distribute",
        vb:row{
            vb:text{text="Morph style:", width=text_width},
            vb:popup{
                id="morph",
                width=valuebox_width,
                items={"EaseIn", "EaseOut", "Spike"},
                value=1,
            },
        },
    },
    vb:horizontal_aligner{
        mode = "distribute",
        vb:row{
            vb:text{text="Attack/Decay:", width=text_width},
            vb:slider{
                id="time",
                width=valuebox_width,
                min=1,
                max=10,
                value=1,
            },
        },
    },
    vb:horizontal_aligner{
        mode = "distribute",
        vb:row{
            vb:text{text="Sample loop:", width=text_width},
            vb:popup{
                id="loop",
                width=valuebox_width,
                items={"NoLoop", "Forward", "Backward", "PingPong", "Fortune :)"},
                value=1,
            },
        },
    },
    vb:horizontal_aligner{
        mode = "distribute",
        vb:row{
            vb:text{text="IMapping:", width=text_width},
            vb:popup{
                id="overlay",
                width=valuebox_width,
                items={"PlayAll", "Cycle", "Random"},
                value=1,
            },
        },
    },
    vb:horizontal_aligner{
        mode = "left",
        vb:row{
            vb:text{text="Rand Loop ?", width=text_width},
            vb:checkbox{
                id="random_loops",
                width=20,
                value=false,
            },
        },
    },
    vb:horizontal_aligner{
        mode = "left",
        vb:row{
            vb:text{text="Transpose ?", width=text_width},
            vb:checkbox{
                id="transpose",
                width=20,
                value=false,
            },
        },
    },
    vb:horizontal_aligner{
        mode = "left",
        vb:row{
            vb:text{text="Delete origs ?", width=text_width},
            vb:checkbox{
                id="delete_originals",
                width=20,
                value=false,
            },
        },
    },
    vb:space{height=10},
    vb:button{text="Generate wavetable",
        width=text_width + valuebox_width,
        height=22,
        notifier = function()
            create_wavetable()
        end
    },
}