---@diagnostic disable: deprecated
NOTE_BASE = 2 ^ (1.0 / 12.0)
EPSILON = 1e-12
MINUSINFDB = 200
PI = math.pi
TWOPI = math.pi * 2
HALFPI = math.pi * 0.5
NOTES = {"C-", "C#", "D-", "D#", "E-", "F-", "F#", "G-", "G#", "A-", "A#", "B-"}

function Int(value)
    -- vrací celé číslo

    local f = math.floor(value)
    if value == f or value % 2 == 0.5 then
        return f
    else
        return math.floor(value + 0.5)
    end
end

function Log2(value)
    -- logaritmus 2

    return math.log(value) / math.log(2)
end

function Clamp(value, minimum, maximum)
    -- vrací hodnotu mezi min a max

    return math.max(math.min(value, maximum), minimum)
end

function Frequency2Note(frequency)
    -- převede frekvenci na číslo midi noty

    return 69 + Int(12 * Log2(frequency / 440.0))
end

function Note2Frequency(note)
    -- převede číslo midi noty na její frekvenci

    return 440.0 * 2 ^ ((note - 69) / 12)
end

function Convert_linear_to_db(value)
    if value > EPSILON then
        return math.log10(value) * 20
    else
        return MINUSINFDB
    end
end

function Convert_db_to_linear(value)
    if value > MINUSINFDB then
        return math.pow(10.0, value * 0.05)
    else
        return 0.0
    end
end

function imprecise_lerp(y0, y1, t)
    return y0 + t * (y1 - y0)
end


function precise_lerp(y0, y1, t)
    return (1 - t) * y0 + t * y1
end

function Flip(t)
    return 1 - t
end

function EaseIn(t, nr)
    return math.pow(t, nr)
end

function EaseOut(t, nr)
    return Flip(math.pow(Flip(t), nr))
end

function EaseInOut(t)
    return precise_lerp(EaseIn(t), EaseOut(t), t)
end

function Spike(t, nr)
    if t <= 0.5 then return EaseIn(t / 0.5, nr) end
    return EaseIn(Flip(t) / 0.5, nr)
end

function circular_cross_correlation(buffer1, buffer2)
    local N = 10
    local sum = 0
    local m = 1
    for N=1, #buffer1 do
        sum = sum + (buffer1[N] * buffer2[(N + m) % #buffer1])
    end
end

function linear_convolution(buffer1, buffer2)
    local buffer = {}
    for n=1, #buffer1-1 do
        for k=1, #buffer1-1 do
            if n >= k then
                buffer[n] = buffer[n] + buffer1[n - k] * buffer2[k]
            end
        end
    end
    return buffer
end